import { ComponentFixture, TestBed } from '@angular/core/testing';
import { ActivatedRoute } from '@angular/router';
import { of } from 'rxjs';

import { SavedSearchesDetailComponent } from './saved-searches-detail.component';

describe('SavedSearches Management Detail Component', () => {
  let comp: SavedSearchesDetailComponent;
  let fixture: ComponentFixture<SavedSearchesDetailComponent>;

  beforeEach(() => {
    TestBed.configureTestingModule({
      declarations: [SavedSearchesDetailComponent],
      providers: [
        {
          provide: ActivatedRoute,
          useValue: { data: of({ savedSearches: { id: 123 } }) },
        },
      ],
    })
      .overrideTemplate(SavedSearchesDetailComponent, '')
      .compileComponents();
    fixture = TestBed.createComponent(SavedSearchesDetailComponent);
    comp = fixture.componentInstance;
  });

  describe('OnInit', () => {
    it('Should load savedSearches on init', () => {
      // WHEN
      comp.ngOnInit();

      // THEN
      expect(comp.savedSearches).toEqual(expect.objectContaining({ id: 123 }));
    });
  });
});
