import { ComponentFixture, TestBed } from '@angular/core/testing';
import { of } from 'rxjs';
import { HttpHeaders, HttpResponse } from '@angular/common/http';

import { LikesComponent } from 'app/entities/likes/likes.component';
import { LikesService } from 'app/entities/likes/likes.service';
import { Likes } from 'app/shared/model/likes.model';

describe('Component Tests', () => {
  describe('Likes Management Component', () => {
    let comp: LikesComponent;
    let fixture: ComponentFixture<LikesComponent>;
    let service: LikesService;

    beforeEach(() => {
      TestBed.configureTestingModule({
        imports: [],
        declarations: [LikesComponent],
      })
        .overrideTemplate(LikesComponent, '')
        .compileComponents();

      fixture = TestBed.createComponent(LikesComponent);
      comp = fixture.componentInstance;
      service = fixture.debugElement.injector.get(LikesService);
    });

    it('Should call load all on init', () => {
      // GIVEN
      const headers = new HttpHeaders().append('link', 'link;link');
      spyOn(service, 'query').and.returnValue(
        of(
          new HttpResponse({
            body: [new Likes(123)],
            headers,
          })
        )
      );

      // WHEN
      comp.ngOnInit();

      // THEN
      expect(service.query).toHaveBeenCalled();
      expect(comp.likes && comp.likes[0]).toEqual(jasmine.objectContaining({ id: 123 }));

      it('Like should be deleted when clicking on delete', () => {
        comp.ngOnInit();
        expect(comp.trackId(1, new Likes(1))).toBe(1);
      });
    });
  });
});
